﻿// Kerbal Engineer Redux
// Author:  CYBUTEK
// License: Attribution-NonCommercial-ShareAlike 3.0 Unported

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Engineer
{
    class Ship
    {
        public List<Stage> Stages
        {
            get;
            private set;
        }

        public Ship()
        {
            Stages = new List<Stage>();
        }

        public void Update(List<Part> parts)
        {
            foreach (Stage stage in Stages)
            {
                if (!stage.Exists)
                {
                    Stages.Clear();
                    break;
                }
            }

            for (int i = 0; i <= Stages.Count; i++)
            {
                if (i < Stages.Count)
                {
                    if (!Stages[i].Update(parts))
                        Stages.RemoveAt(i);
                }
                else
                {
                    Stage stage = new Stage(i, this);

                    if (stage.Update(parts))
                        Stages.Add(stage);
                }
            }
        }
    }
}
